Parameters:
  KeyName:
    Description: "Use this keypair to access via SSH"
    Type: AWS::EC2::KeyPair::KeyName  

Mappings:
  RegionMap:
    ap-southeast-1:
      RegionA: ap-southeast-1a
      RegionB: ap-southeast-1b
      RegionC: ap-southeast-1c
#      AMI: ami-0bb35a5dad5658286  # Ubuntu
#      AMI: ami-04a2d6660f1296314  # Red Hat 8.0
      AMI: ami-0f32a4c33f049f940 # Red Hat 8.0 Linux 101
    us-east-1:
      RegionA: us-east-1a
      RegionB: us-east-1b
      RegionC: us-east-1c
      RegionD: us-east-1d
      RegionE: us-east-1e
      RegionF: us-east-1f
      AMI: ami-026c8acd92718196b

Resources:
  myVPC:
    Type: AWS::EC2::VPC
    Properties:
      CidrBlock: 10.10.0.0/16
      EnableDnsSupport: 'true'
      EnableDnsHostnames: 'false'
      InstanceTenancy: default
      Tags:
        - Key: Name
          Value: CVPC

  myInternetGateway:
    Type: AWS::EC2::InternetGateway
    Properties:
      Tags:
        - Key: Name
          Value: IGW1

  myAttachGateway:
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      VpcId: !Ref myVPC
      InternetGatewayId: !Ref myInternetGateway

  myEIP:
    Type: AWS::EC2::EIP
    Properties:
      InstanceId: !Ref Ec2Instance1

  mySubnet:
    Type: AWS::EC2::Subnet
    Properties:
      VpcId: !Ref myVPC
      CidrBlock: 10.10.10.0/24
      AvailabilityZone:
        Fn::FindInMap:
        - RegionMap
        - !Ref AWS::Region
        - RegionA
      Tags:
        - Key: Name
          Value: cSubnet

  myRouteTable:
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref myVPC
      Tags:
        - Key: Name
          Value: RTBL1

  mySubnetRouteTableAssociation:
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      SubnetId: !Ref mySubnet
      RouteTableId: !Ref myRouteTable

  myRoute:
    Type: AWS::EC2::Route
    #DependsOn: GatewayToInternet
    Properties:
      RouteTableId: !Ref myRouteTable
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref myInternetGateway

  SecGrpCF1:
    Type: "AWS::EC2::SecurityGroup"
    Properties:
      GroupDescription: "Public facing security group"
      VpcId: !Ref myVPC
      SecurityGroupIngress:
        - IpProtocol: tcp
          FromPort: '22'
          ToPort: '22'
          CidrIp: 202.135.245.13/32
        - IpProtocol : tcp
          FromPort: '80'
          ToPort: '80'
          CidrIp: 202.135.245.13/32
        - IpProtocol: tcp
          FromPort: '22'
          ToPort: '22'
          CidrIp: 10.10.10.0/24
        - IpProtocol : icmp
          FromPort: '8'
          ToPort: '-1'
          CidrIp: 10.10.10.0/24
        - IpProtocol : tcp
          FromPort: '2222'
          ToPort: '2222'
          CidrIp: 10.10.10.0/24
      Tags:
        - Key: Name
          Value: "SecuGroup"

  Ec2Instance1:
    Type: "AWS::EC2::Instance"
    Properties:
      SubnetId: !Ref mySubnet
      InstanceType: t2.micro
      ImageId:
        Fn::FindInMap:
        - RegionMap
        - !Ref AWS::Region
        - AMI
      Tags:
        - Key: Name
          Value: "DevOPs 101"
      KeyName: !Ref KeyName
      SecurityGroupIds: 
        - !Ref SecGrpCF1

  Ec2Bastion1:
    Type: "AWS::EC2::Instance"
    Properties:
      SubnetId: !Ref mySubnet
      InstanceType: t2.micro
      ImageId:
        Fn::FindInMap:
        - RegionMap
        - !Ref AWS::Region
        - AMI
      Tags:
        - Key: Name
          Value: "Bastion 1"
      KeyName: !Ref KeyName
      SecurityGroupIds: 
        - !Ref SecGrpCF1

Outputs:
  Server1ID:
    Value: !Ref Ec2Instance1

  Server1ID:
    Value: !Ref Ec2Bastion1
